/**************************************************************************************
 Copyright (c) 2002
      The UbixOS Project

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: getfreevirtualpage.c,v 1.3 2003/04/24 00:16:30 reddawg Exp $
**************************************************************************************/

#include <vmm/paging.h>
#include <vmm/memory.h>
#include <ubixos/schedule.h>

/************************************************************************

Function: void *getFreeVirtualPage(pid_t pid,int count);
Description: Returns A Free Page Mapped To The VM Space
Notes:

08/11/02 - This Will Return Next Avilable Free Page Of Tasks VM Space

************************************************************************/
void *getFreeVirtualPage(pid_t pid,int count) {
  int x=0,y=0,c=0;
  uInt32 *pageTableSrc = 0x0;
  uInt32 *pageDir     = (uInt32 *)parentPageDirAddr;

  //Lets Search For A Free Page
  for (x=(_current->oInfo.vmStart/(1024*4096));x<1024;x++) {
    //Set Page Table Address
    if ((pageDir[x] & pagePresent) != pagePresent) {
      //If Page Table Is Non Existant Then Set It Up
      pageDir[x] = (uLong)findFreePage(_current->id) | pageDefault;
      //Also Add It To Virtual Space So We Can Make Changes Later
      pageTableSrc = (uLong *)(tablesBaseAddress + (4096 * 767));
      pageTableSrc[x] = pageDir[x];
      //Reload Page Directory
      asm(
        "movl %cr3,%eax\n"
        "movl %eax,%cr3\n"
        );
      }    
    pageTableSrc = (uInt32 *)(tablesBaseAddress + (0x1000*x));
    for (y=0;y<1024;y++) {
      //Loop Through The Page Table Find An UnAllocated Page
      if ((uInt32)pageTableSrc[y] == (uInt32)0x0) {
        if (count > 0x1) {
          for (c=0;c<count;c++) {
            if ((uInt32)pageTableSrc[y+c] != (uInt32)0x0) {
              c = -1;
              break;
              }
            }
          if (c != -1) {
            for (c=0;c<count;c++) {
              remapPage((uInt32)findFreePage(pid),((x*(1024*4096))+((y+c)*4096)));
              clearVirtualPage((uInt32)((x*(1024*4096))+((y+c)*4096)));
              }
            return((void *)((x*(1024*4096))+(y*4096)));
            }
          }
        else {
          //Map A Physical Page To The Virtual Page
          //remapPage((uInt32)findFreePage(pid),((x*(1024*4096))+(y*4096)),pid);
          remapPage((uInt32)findFreePage(pid),((x*(1024*4096))+(y*4096)));
          //Clear This Page So No Garbage Is There
          clearVirtualPage((uInt32)((x*(1024*4096))+(y*4096)));
          //Return The Address Of The Newly Allocate Page
          return((void *)((x*(1024*4096))+(y*4096)));
          }
        }
      }
    }
  //If No Free Page Was Found Return NULL
  return(0x0);
  }
